/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-jsk-rviz-plugins-1.0.24-0precise-20150916-0037/msg/OverlayMenu.msg
 *
 */


#ifndef JSK_RVIZ_PLUGINS_MESSAGE_OVERLAYMENU_H
#define JSK_RVIZ_PLUGINS_MESSAGE_OVERLAYMENU_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace jsk_rviz_plugins
{
template <class ContainerAllocator>
struct OverlayMenu_
{
  typedef OverlayMenu_<ContainerAllocator> Type;

  OverlayMenu_()
    : action(0)
    , current_index(0)
    , menus()
    , title()  {
    }
  OverlayMenu_(const ContainerAllocator& _alloc)
    : action(0)
    , current_index(0)
    , menus(_alloc)
    , title(_alloc)  {
    }



   typedef int32_t _action_type;
  _action_type action;

   typedef uint32_t _current_index_type;
  _current_index_type current_index;

   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _menus_type;
  _menus_type menus;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _title_type;
  _title_type title;


    enum { ACTION_SELECT = 0 };
     enum { ACTION_CLOSE = 1 };
 

  typedef boost::shared_ptr< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct OverlayMenu_

typedef ::jsk_rviz_plugins::OverlayMenu_<std::allocator<void> > OverlayMenu;

typedef boost::shared_ptr< ::jsk_rviz_plugins::OverlayMenu > OverlayMenuPtr;
typedef boost::shared_ptr< ::jsk_rviz_plugins::OverlayMenu const> OverlayMenuConstPtr;

// constants requiring out of line definition

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace jsk_rviz_plugins

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'jsk_rviz_plugins': ['/tmp/buildd/ros-hydro-jsk-rviz-plugins-1.0.24-0precise-20150916-0037/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> >
{
  static const char* value()
  {
    return "fed3c7e9788f7ee37908107a2597b619";
  }

  static const char* value(const ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xfed3c7e9788f7ee3ULL;
  static const uint64_t static_value2 = 0x7908107a2597b619ULL;
};

template<class ContainerAllocator>
struct DataType< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> >
{
  static const char* value()
  {
    return "jsk_rviz_plugins/OverlayMenu";
  }

  static const char* value(const ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> >
{
  static const char* value()
  {
    return "int32 ACTION_SELECT=0\n\
int32 ACTION_CLOSE=1\n\
int32 action\n\
uint32 current_index\n\
string[] menus\n\
string title\n\
";
  }

  static const char* value(const ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.action);
      stream.next(m.current_index);
      stream.next(m.menus);
      stream.next(m.title);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct OverlayMenu_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::jsk_rviz_plugins::OverlayMenu_<ContainerAllocator>& v)
  {
    s << indent << "action: ";
    Printer<int32_t>::stream(s, indent + "  ", v.action);
    s << indent << "current_index: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.current_index);
    s << indent << "menus[]" << std::endl;
    for (size_t i = 0; i < v.menus.size(); ++i)
    {
      s << indent << "  menus[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.menus[i]);
    }
    s << indent << "title: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.title);
  }
};

} // namespace message_operations
} // namespace ros

#endif // JSK_RVIZ_PLUGINS_MESSAGE_OVERLAYMENU_H
